"use strict"; 
( function( wp ) {
	var registerPlugin = wp.plugins.registerPlugin;
	var PluginSidebar = wp.editPost.PluginSidebar;
	var el = wp.element.createElement;
    
	registerPlugin( 'spinomatic-sidebar', {
		render: function() {
            function updateMessage( ) {
                var postId = wp.data.select("core/editor").getCurrentPostId();
                if (confirm("Are you sure you want to submit this post now?") == true) {
                    document.getElementById('spinomatic_submit_post').setAttribute('disabled','disabled');
                    document.getElementById("spinomatic_span").innerHTML = 'Posting status: Submitting... (please do not close or refresh this page) ';
                    var data = {
                         action: 'spinomatic_post_now',
                         id: postId
                    };
                    jQuery.post(ajaxurl, data, function(response) {
                        document.getElementById('spinomatic_submit_post').removeAttribute('disabled');
                        document.getElementById("spinomatic_span").innerHTML = 'Posting status: Done! ';
                    }).fail( function(xhr) 
                    {
                        document.getElementById("spinomatic_span").innerHTML = 'Error, please check the plugin\'s \'Activity and Logging\' menu for details!';
                        console.log('Error occured in processing: ' + xhr.statusText + ' - please check plugin\'s \'Activity and Logging\' menu for details.');
                    });
                } else {
                    return;
                }
            }
			return el( PluginSidebar,
				{
					name: 'spinomatic-sidebar',
					icon: 'text',
					title: 'Spinomatic Post Spinner',
				},
				el(
                    'div', 
                    { className: 'coderevolution_gutenberg_div' },
                    el(
                        'h4',
                        { className: 'coderevolution_gutenberg_title' },
                        'Spin Post Now '
                    ),
                    el(
                        'input',
                        { type:'button', id:'spinomatic_submit_post', value:'Spin Post Now!', onClick: updateMessage, className: 'coderevolution_gutenberg_button button button-primary' }
                    ),
                    el(
                    'br'
                    ),
                    el(
                    'br'
                    ),
                    el(
                        'div', 
                        {id:'spinomatic_span'},
                        'Posting status: idle'
                    )
				)
			);
		},
	} );
} )( window.wp );