"use strict"; 
var { registerBlockType } = wp.blocks;
var gcel = wp.element.createElement;

registerBlockType( 'spinomatic-spintax-post-generator/spinomatic-spintax', {
    title: 'Spinomatic Spintax Embed',
    icon: 'text',
    category: 'embed',
    attributes: {
        min_blocks : {
            default: '',
            type:   'string',
        },
        max_blocks : {
            default: '',
            type:   'string',
        },
        no_refresh : {
            default: '',
            type:   'string',
        },
        spin_content : {
            default: '',
            type:   'string',
        }
    },
    keywords: ['list', 'posts', 'spinomatic'],
    edit: (function( props ) {
		var min_blocks = props.attributes.min_blocks;
        var max_blocks = props.attributes.max_blocks;
        var spin_content = props.attributes.spin_content;
        var no_refresh = props.attributes.no_refresh;
		function updateMessage( event ) {
            props.setAttributes( { min_blocks: event.target.value} );
		}
        function updateMessage2( event ) {
            props.setAttributes( { max_blocks: event.target.value} );
		}
        function updateMessage3( event ) {
            props.setAttributes( { no_refresh: event.target.value} );
		}
        function updateMessage4( event ) {
            props.setAttributes( { spin_content: event.target.value} );
		}
		return gcel(
			'div', 
			{ className: 'coderevolution_gutenberg_div' },
            gcel(
				'h4',
				{ className: 'coderevolution_gutenberg_title' },
                'Spinomatic Spintax Embed ',
                gcel(
                    'div', 
                    {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                    ,
                    gcel(
                        'div', 
                        {className:'bws_hidden_help_text'},
                        'This block is used to embed a spintax.'
                    )
                )
			),
            gcel(
				'label',
				{ className: 'coderevolution_gutenberg_label' },
                'Min Blocks: '
			),
            gcel(
                'div', 
                {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                ,
                gcel(
                    'div', 
                    {className:'bws_hidden_help_text'},
                    'Input the minimum number of blocks.'
                )
            ),
			gcel(
				'input',
				{ type:'number',min:1,placeholder:'Min # blocks', value: min_blocks, onChange: updateMessage, className: 'coderevolution_gutenberg_input' }
			),
            gcel(
				'br'
			),
            gcel(
				'label',
				{ className: 'coderevolution_gutenberg_label' },
                'Max Blocks: '
			),
            gcel(
                'div', 
                {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                ,
                gcel(
                    'div', 
                    {className:'bws_hidden_help_text'},
                    'Input the maximum number of blocks.'
                )
            ),
			gcel(
				'input',
				{ type:'number',min:0,placeholder:'Max # blocks', value: max_blocks, onChange: updateMessage2, className: 'coderevolution_gutenberg_input' }
			),
            gcel(
				'br'
			),
            gcel(
				'label',
				{ className: 'coderevolution_gutenberg_label' },
                'No Content Refresh: '
			),
            gcel(
                'div', 
                {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                ,
                gcel(
                    'div', 
                    {className:'bws_hidden_help_text'},
                    'Select if the first spinned text should be permanent.'
                )
            ),
			gcel(
				'select',
				{ value: no_refresh, onChange: updateMessage3, className: 'coderevolution_gutenberg_select' }, 
                gcel(
                    'option',
                    { value: '1'},
                    'No Refresh'
                ), 
                gcel(
                    'option',
                    { value: '0'},
                    'Refresh'
                )
            ),
            gcel(
				'br'
			),
            gcel(
				'label',
				{ className: 'coderevolution_gutenberg_label' },
                'Spintax Text: '
			),
            gcel(
                'div', 
                {className:'bws_help_box bws_help_box_right dashicons dashicons-editor-help'}
                ,
                gcel(
                    'div', 
                    {className:'bws_hidden_help_text'},
                    'Input the Spintax to be spinned.'
                )
            ),
			gcel(
				'textarea',
				{ rows:1,placeholder:'{Writing|Creating} {articles|stories} is a {lot of fun|rewarding experience}.', value: spin_content, onChange: updateMessage4, className: 'coderevolution_gutenberg_input' }
			)
		);
    }),
    save: (function( props ) {
       return null;
    }),
} );